﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Documents;
using System.Windows.Shapes;

namespace wpf_ChartView__919978
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.root.Opacity = 0.1;

            // Dispatch the update, otherwise everything will happen right away and the UI will not get faded.
            this.Dispatcher.BeginInvoke((Action)(() =>
            {
                this.DataContext = this.GenerateData();
                this.chart1.UIUpdated += this.chart1_UIUpdated;
            }), System.Windows.Threading.DispatcherPriority.Input);
        }

        private void chart1_UIUpdated(object sender, EventArgs e)
        {
            // we can see that the path is fully set up
            var path = Telerik.Windows.Controls.ChildrenOfTypeExtensions.ChildrenOfType<Path>(this.chart1.Series[0]).First();
            var data = path.Data;

            this.chart1.UIUpdated -= this.chart1_UIUpdated;
            this.root.Opacity = 1.0;
        }

        private object GenerateData()
        {
            List<PlotInfo> data = new List<PlotInfo>();
            DateTime now = DateTime.Now;

            for (int i = 0; i < 500000; i++)
            {
                PlotInfo pi = new PlotInfo { XCat = now.AddSeconds(i), YVal = i % 14 + i % 10 + i % 7 + i % 3 };
                data.Add(pi);
            }

            return data;
        }
    }

    public class PlotInfo
    {
        public DateTime XCat { get; set; }
        public double YVal { get; set; }
    }
}
